#include <stdio.h>
int KEY_LEFT_CTRL       = 0x80 ;
int KEY_LEFT_SHIFT  	= 0x81 ;
int KEY_LEFT_ALT        = 0x82 ;
int KEY_LEFT_GUI   		= 0x83 ;
int KEY_RIGHT_CTRL  	= 0x84 ;
int KEY_RIGHT_SHIFT 	= 0x85 ;
int KEY_RIGHT_ALT       = 0x86 ;
int KEY_RIGHT_GUI       = 0x87 ;
int KEY_UP_ARROW        = 0xDA ;
int KEY_DOWN_ARROW  	= 0xD9 ;
int KEY_LEFT_ARROW      = 0xD8 ;
int KEY_RIGHT_ARROW 	= 0xD7 ;
int KEY_BACKSPACE       = 0xB2 ;
int KEY_TAB       	    = 0xB3 ;
int KEY_RETURN          = 0xB0 ;
int KEY_ESC       	    = 0xB1 ;
int KEY_INSERT    		= 0xD1 ;
int KEY_DELETE    		= 0xD4 ;
int KEY_PAGE_UP   		= 0xD3 ;
int KEY_PAGE_DOWN 		= 0xD6 ;
int KEY_HOME      	    = 0xD2 ;
int KEY_END      	    = 0xD5 ;
int KEY_CAPS_LOCK  	    = 0xC1 ;
int KEY_F1       	    = 0xC2 ;
int KEY_F2       	    = 0xC3 ;
int KEY_F3       	    = 0xC4 ;
int KEY_F4       	    = 0xC5 ;
int KEY_F5       	    = 0xC6 ;
int KEY_F6       	    = 0xC7 ;
int KEY_F7       	    = 0xC8 ;
int KEY_F8       	    = 0xC9 ;
int KEY_F9       	    = 0xCA ;
int KEY_F10      	    = 0xCB ;
int KEY_F11      	    = 0xCC ;
int KEY_F12      	    = 0xCD ;
void press(int key){            printf(" Press : %i\n", key);            };
void release(int key){          printf(" Release : %i\n", key);          };   
void releaseAll(){              printf(" Release All\n");                }; 
void println(char *str){        printf(" println : %s\n", str);          };        
void delay(int milliseconde){   printf(" Wait : %i ms\n", milliseconde); };
struct KeyboardModel{
    void (*press)(int);
    void (*release)(int);
    void (*println)(char*);
    void (*releaseAll)();
} Keyboard; 
struct KeyboardModel Keyboard = {press, release ,println, releaseAll}; 

/*
*
*   Arduino Program
*
*
*/

void JustOncePressKey(int key){
    Keyboard.press(key); 
    delay(100);
    Keyboard.releaseAll();
}

void getCharFromWindowsCharTab(int cols, int row){  
  int i = 0;
  //ouverture de la table de caractere Windows
  Keyboard.press(KEY_LEFT_CTRL);
  Keyboard.press(KEY_ESC);
  delay(100);
  Keyboard.releaseAll();
  delay(1000);
  Keyboard.println("charmap.exe");
  delay(250);
  // Double Tab
  while (i++ <= 1){         JustOncePressKey(KEY_TAB); } 
  i = 0;
  //Deplacement dans le tableau
  while (i++ <= (cols-1)) { JustOncePressKey(KEY_LEFT_ARROW);  }
  i = 0;
  while (i++ <= (row-1)) {  JustOncePressKey(KEY_DOWN_ARROW); }
  //Selection du caractere - touche entree
  Keyboard.println("");
  //Triple Tab
  i = 0;
  while (i++ <= 2){          JustOncePressKey(KEY_TAB);     }
  //touche entree
  Keyboard.println("");
  //Fermeture Alt+F4
  Keyboard.press(KEY_LEFT_ALT);
  Keyboard.press(KEY_F4);
  delay(100);
  Keyboard.releaseAll();
}


void setup()
{
   getCharFromWindowsCharTab(19,2); // get "\n" in clipboard
}



int main(){
    setup();   
    return -1;
}

